searchNodes=[{"ref":"Xcribe.html","title":"Xcribe","type":"module","doc":"This is the documentation for the XCribe Project XCribe was built to generate API documentation for your app tests."},{"ref":"Xcribe.Config.html","title":"Xcribe.Config","type":"module","doc":"Handle Xcribe configurations. You must configure Xcribe in your test config file config/test.exs as: config: xcribe, [ information_source: YourApp.YouModuleInformation, format: :swagger, output: &quot;app_doc.json&quot;, env_var: &quot;CI_ENV_FOR_DOC&quot;, json_library: Jason ] :api_blueprint -&gt; &quot;api_doc.apib&quot; :swagger -&gt; &quot;openapi.json&quot; Available configurations: :information_source - Module that implements Xcribe.Information with API information. It&#39;s required. :output - The name of file output with generated configuration. Default value changes by the format, &#39;api_blueprint.apib&#39; for Blueprint and &#39;app_doc.json&#39; for swagger. :format - Format to generate documentation, allowed :api_blueprint and :swagger. Default :api_blueprint. :env_var - Environment variable name for active Xcribe documentation generator. Default is XCRIBE_ENV. :json_library - The library to be used for json decode/encode (Jason and Poison are supported). The default is the same as Phoenix configuration."},{"ref":"Xcribe.Config.html#active?/0","title":"Xcribe.Config.active?/0","type":"function","doc":"Return if Xcribe should document the specs. It&#39;s determined by an env var XCRIBE_ENV. Don&#39;t matter the var content if it&#39;s defined Xcribe will generate documentation. The env var name can changed by configuration: config :xcribe, [ env_var: &quot;CUSTOM_ENV_NAME&quot; ]"},{"ref":"Xcribe.Config.html#doc_format/0","title":"Xcribe.Config.doc_format/0","type":"function","doc":"Return the format for documentation. Default is :api_blueprint. If an invalid format is given an Xcribe.UnknownFormat exception will raise. To configure the documentation format: config :xcribe, [ format: :swagger ]"},{"ref":"Xcribe.Config.html#json_library/0","title":"Xcribe.Config.json_library/0","type":"function","doc":"Return configured json library. If no custom lib was configured the Phoenix configuration will be used. To configure: config :xcribe, [ json_library: Jason ]"},{"ref":"Xcribe.Config.html#output_file/0","title":"Xcribe.Config.output_file/0","type":"function","doc":"Return the file name to output generated documentation. If no config was given the default names are api_doc.apib for Blueprint format and openapi.json for Swagger format. To configure output name: config :xcribe, [ output: &quot;custom_name.json&quot; ]"},{"ref":"Xcribe.Config.html#xcribe_information_source/0","title":"Xcribe.Config.xcribe_information_source/0","type":"function","doc":"Return the iformation module with API information (Xcribe.Information). If information source is not given an Xcribe.MissingInformationSource exception will raise. To configure the source: config :xcribe, [ information_source: YourApp.YouModuleInformation ]"},{"ref":"Xcribe.ConnParser.html","title":"Xcribe.ConnParser","type":"module","doc":"Used to convert a Plug.Conn to a Xcribe.Request. Each connection sent to documenting in your tests is given to ConnParser. Is expected that connection has been passed through the app Endpoint as a finished request. The parser will extract all needed info from Conn and uses app Router for additional information about the request. The atribute description must be given at document macro call with the option :as: test &quot;test name&quot;, %{conn: conn} do ... Xcribe.Helpers.Document.document(conn, as: &quot;description here&quot;) ... end If no description is given the current test description will be used."},{"ref":"Xcribe.ConnParser.html#execute/2","title":"Xcribe.ConnParser.execute/2","type":"function","doc":"Parse the given Plug.Conn and transform it to a Xcribe.Request. A description can be provided."},{"ref":"Xcribe.ContentDecoder.html","title":"Xcribe.ContentDecoder","type":"module","doc":"Used to decode requests content to an elixir collection (map, list, etc) Currently only json is supported and the module Xcribe.JSON is used to decode given value."},{"ref":"Xcribe.ContentDecoder.html#decode!/2","title":"Xcribe.ContentDecoder.decode!/2","type":"function","doc":"Decode value by the given content_type. iex&gt; ContentDecoder.decode!(&quot;{&quot;key&quot;:&quot;value&quot;}&quot;, &quot;application/json&quot;) %{&quot;key&quot; =&gt; &quot;value&quot;} An UnknownType excption is raised when given content_type is unknown."},{"ref":"Xcribe.ContentDecoder.UnknownType.html","title":"Xcribe.ContentDecoder.UnknownType","type":"exception","doc":"Raised at runtime when can&#39;t decode an unknown content type."},{"ref":"Xcribe.Formatter.html","title":"Xcribe.Formatter","type":"module","doc":""},{"ref":"Xcribe.Formatter.html#child_spec/1","title":"Xcribe.Formatter.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xcribe.Formatter.html#init/1","title":"Xcribe.Formatter.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Xcribe.Information.html","title":"Xcribe.Information","type":"module","doc":""},{"ref":"Xcribe.Information.html#default_description/0","title":"Xcribe.Information.default_description/0","type":"function","doc":""},{"ref":"Xcribe.Information.html#default_host/0","title":"Xcribe.Information.default_host/0","type":"function","doc":""},{"ref":"Xcribe.Information.html#default_name/0","title":"Xcribe.Information.default_name/0","type":"function","doc":""},{"ref":"Xcribe.Information.html#fetch_key/3","title":"Xcribe.Information.fetch_key/3","type":"function","doc":""},{"ref":"Xcribe.Information.html#stringfy_keys/1","title":"Xcribe.Information.stringfy_keys/1","type":"function","doc":""},{"ref":"Xcribe.Information.html#xcribe_info/1","title":"Xcribe.Information.xcribe_info/1","type":"macro","doc":""},{"ref":"Xcribe.Information.html#xcribe_info/2","title":"Xcribe.Information.xcribe_info/2","type":"macro","doc":""},{"ref":"Xcribe.JSON.html","title":"Xcribe.JSON","type":"module","doc":"Wrapper for a JSON library. Poison and Jason are the most popular json libraries common used in Elixir projects. Xcribe works with both. By default Xcribe use the same library as Phoenix. But you can change it by config, see Xcribe.Config."},{"ref":"Xcribe.JSON.html#decode/2","title":"Xcribe.JSON.decode/2","type":"function","doc":"wrapper for json library decode function"},{"ref":"Xcribe.JSON.html#decode!/2","title":"Xcribe.JSON.decode!/2","type":"function","doc":"wrapper for json library decode! function"},{"ref":"Xcribe.JSON.html#encode/2","title":"Xcribe.JSON.encode/2","type":"function","doc":"wrapper for json library encode function"},{"ref":"Xcribe.JSON.html#encode!/2","title":"Xcribe.JSON.encode!/2","type":"function","doc":"wrapper for json library encode! function"},{"ref":"Xcribe.MissingInformationSource.html","title":"Xcribe.MissingInformationSource","type":"exception","doc":"Raised at runtime when not configured an implementation of Xcribe.Information."},{"ref":"Xcribe.Recorder.html","title":"Xcribe.Recorder","type":"module","doc":""},{"ref":"Xcribe.Recorder.html#child_spec/1","title":"Xcribe.Recorder.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Xcribe.Recorder.html#get_all/0","title":"Xcribe.Recorder.get_all/0","type":"function","doc":""},{"ref":"Xcribe.Recorder.html#init/1","title":"Xcribe.Recorder.init/1","type":"function","doc":"Invoked when the server is started. start_link/3 or start/3 will block until it returns. init_arg is the argument term (second argument) passed to start_link/3. Returning {:ok, state} will cause start_link/3 to return {:ok, pid} and the process to enter its loop. Returning {:ok, state, timeout} is similar to {:ok, state}, except that it also sets a timeout. See the &quot;Timeouts&quot; section in the module documentation for more information. Returning {:ok, state, :hibernate} is similar to {:ok, state} except the process is hibernated before entering the loop. See c:handle_call/3 for more information on hibernation. Returning {:ok, state, {:continue, continue}} is similar to {:ok, state} except that immediately after entering the loop the c:handle_continue/2 callback will be invoked with the value continue as first argument. Returning :ignore will cause start_link/3 to return :ignore and the process will exit normally without entering the loop or calling c:terminate/2. If used when part of a supervision tree the parent supervisor will not fail to start nor immediately try to restart the GenServer. The remainder of the supervision tree will be started and so the GenServer should not be required by other processes. It can be started later with Supervisor.restart_child/2 as the child specification is saved in the parent supervisor. The main use cases for this are: The GenServer is disabled by configuration but might be enabled later. An error occurred and it will be handled by a different mechanism than the Supervisor. Likely this approach involves calling Supervisor.restart_child/2 after a delay to attempt a restart. Returning {:stop, reason} will cause start_link/3 to return {:error, reason} and the process to exit with reason reason without entering the loop or calling c:terminate/2. Callback implementation for GenServer.init/1."},{"ref":"Xcribe.Recorder.html#save/1","title":"Xcribe.Recorder.save/1","type":"function","doc":""},{"ref":"Xcribe.Recorder.html#start_link/0","title":"Xcribe.Recorder.start_link/0","type":"function","doc":""},{"ref":"Xcribe.Request.html","title":"Xcribe.Request","type":"module","doc":"The struct of a parsed request"},{"ref":"Xcribe.Swagger.Types.html","title":"Xcribe.Swagger.Types","type":"module","doc":"Handle primitive data types. To know more about the primitive types Data Types"},{"ref":"Xcribe.Swagger.Types.html#format_for/1","title":"Xcribe.Swagger.Types.format_for/1","type":"function","doc":"Return the format of given data"},{"ref":"Xcribe.Swagger.Types.html#type_for/1","title":"Xcribe.Swagger.Types.type_for/1","type":"function","doc":"Return the type of given data"},{"ref":"Xcribe.UnknownFormat.html","title":"Xcribe.UnknownFormat","type":"exception","doc":"Raised at runtime when configured format is unknown."},{"ref":"Xcribe.Writter.html","title":"Xcribe.Writter","type":"module","doc":"Writes the documentation to an file on the project."},{"ref":"Xcribe.Writter.html#write/1","title":"Xcribe.Writter.write/1","type":"function","doc":"This writes the given text to the configured output file"},{"ref":"Xcribe.ApiBlueprint.html","title":"Xcribe.ApiBlueprint","type":"module","doc":""},{"ref":"Xcribe.ApiBlueprint.html#generate_doc/1","title":"Xcribe.ApiBlueprint.generate_doc/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.html#group_requests/1","title":"Xcribe.ApiBlueprint.group_requests/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.html#grouped_requests_to_string/1","title":"Xcribe.ApiBlueprint.grouped_requests_to_string/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html","title":"Xcribe.ApiBlueprint.Formatter","type":"module","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#action_parameters/2","title":"Xcribe.ApiBlueprint.Formatter.action_parameters/2","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#action_section/1","title":"Xcribe.ApiBlueprint.Formatter.action_section/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#full_request/2","title":"Xcribe.ApiBlueprint.Formatter.full_request/2","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#metadata_section/1","title":"Xcribe.ApiBlueprint.Formatter.metadata_section/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#request_attributes/2","title":"Xcribe.ApiBlueprint.Formatter.request_attributes/2","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#request_body/1","title":"Xcribe.ApiBlueprint.Formatter.request_body/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#request_headers/1","title":"Xcribe.ApiBlueprint.Formatter.request_headers/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#request_section/1","title":"Xcribe.ApiBlueprint.Formatter.request_section/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#resource_group/1","title":"Xcribe.ApiBlueprint.Formatter.resource_group/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#resource_parameters/2","title":"Xcribe.ApiBlueprint.Formatter.resource_parameters/2","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#resource_section/1","title":"Xcribe.ApiBlueprint.Formatter.resource_section/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#response_body/1","title":"Xcribe.ApiBlueprint.Formatter.response_body/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#response_headers/1","title":"Xcribe.ApiBlueprint.Formatter.response_headers/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Formatter.html#response_section/1","title":"Xcribe.ApiBlueprint.Formatter.response_section/1","type":"function","doc":""},{"ref":"Xcribe.ApiBlueprint.Templates.html","title":"Xcribe.ApiBlueprint.Templates","type":"module","doc":""},{"ref":"Xcribe.Swagger.html","title":"Xcribe.Swagger","type":"module","doc":"Treats list of Requests and generates OpenAPI Document with json format"},{"ref":"Xcribe.Swagger.html#generate_doc/1","title":"Xcribe.Swagger.generate_doc/1","type":"function","doc":"Return an OpenAPI Document builded from the given requests list"},{"ref":"Xcribe.Swagger.Formatter.html","title":"Xcribe.Swagger.Formatter","type":"module","doc":"Format a given Xcribe.Request according to OpenAPI Specification. To know more about the specifications OpenAPI 3.0.3"},{"ref":"Xcribe.Swagger.Formatter.html#info_object/1","title":"Xcribe.Swagger.Formatter.info_object/1","type":"function","doc":"Return an Info Object builded from the api_info suplied by the Xcribe.Information."},{"ref":"Xcribe.Swagger.Formatter.html#merge_parameter_object_lists/2","title":"Xcribe.Swagger.Formatter.merge_parameter_object_lists/2","type":"function","doc":"Merge two lists of parameter object keep uniq names"},{"ref":"Xcribe.Swagger.Formatter.html#merge_path_item_objects/3","title":"Xcribe.Swagger.Formatter.merge_path_item_objects/3","type":"function","doc":"Merge two path item objects"},{"ref":"Xcribe.Swagger.Formatter.html#parameter_objects_from_request/1","title":"Xcribe.Swagger.Formatter.parameter_objects_from_request/1","type":"function","doc":"Return a list of Parameter Objects from a given request."},{"ref":"Xcribe.Swagger.Formatter.html#path_item_object_from_request/1","title":"Xcribe.Swagger.Formatter.path_item_object_from_request/1","type":"function","doc":"Return a Path Item Object from the given request."},{"ref":"Xcribe.Swagger.Formatter.html#raw_openapi_object/0","title":"Xcribe.Swagger.Formatter.raw_openapi_object/0","type":"function","doc":"Return an empty struct of an OpenAPI Object."},{"ref":"Xcribe.Swagger.Formatter.html#request_body_object_from_request/1","title":"Xcribe.Swagger.Formatter.request_body_object_from_request/1","type":"function","doc":"Return a Request Body Object from given request"},{"ref":"Xcribe.Swagger.Formatter.html#response_object_from_request/1","title":"Xcribe.Swagger.Formatter.response_object_from_request/1","type":"function","doc":"Return a Response Object from given request"},{"ref":"Xcribe.Swagger.Formatter.html#schema_object_for/2","title":"Xcribe.Swagger.Formatter.schema_object_for/2","type":"function","doc":"Return an schema object for given attribute/parameter. Options: :title - Include the schema title, default is true. :example - Include the schema example, default is false."},{"ref":"Xcribe.Swagger.Formatter.html#security_requirement_object_by_request/1","title":"Xcribe.Swagger.Formatter.security_requirement_object_by_request/1","type":"function","doc":"Return the security requirement for given request."},{"ref":"Xcribe.Swagger.Formatter.html#security_scheme_object_from_request/1","title":"Xcribe.Swagger.Formatter.security_scheme_object_from_request/1","type":"function","doc":"Return the Security Scheme Object for given request."},{"ref":"Xcribe.Swagger.Formatter.html#server_object/1","title":"Xcribe.Swagger.Formatter.server_object/1","type":"function","doc":"Return a Server Object builded from the api_info suplied by the Xcribe.Information."},{"ref":"Xcribe.Helpers.Document.html","title":"Xcribe.Helpers.Document","type":"module","doc":""},{"ref":"Xcribe.Helpers.Document.html#document/2","title":"Xcribe.Helpers.Document.document/2","type":"macro","doc":""},{"ref":"Xcribe.Helpers.Document.html#request_description/1","title":"Xcribe.Helpers.Document.request_description/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html","title":"Xcribe.Helpers.Formatter","type":"module","doc":"This module implements a set of useful functions for formatter modules."},{"ref":"Xcribe.Helpers.Formatter.html#add_forward_slash/1","title":"Xcribe.Helpers.Formatter.add_forward_slash/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#apply_tab/2","title":"Xcribe.Helpers.Formatter.apply_tab/2","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#apply_template/2","title":"Xcribe.Helpers.Formatter.apply_template/2","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#authorization/1","title":"Xcribe.Helpers.Formatter.authorization/1","type":"function","doc":"return the authorization header from a list of headers"},{"ref":"Xcribe.Helpers.Formatter.html#camelize/1","title":"Xcribe.Helpers.Formatter.camelize/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#camelize_params/1","title":"Xcribe.Helpers.Formatter.camelize_params/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#capitalize/1","title":"Xcribe.Helpers.Formatter.capitalize/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#concat_tab/2","title":"Xcribe.Helpers.Formatter.concat_tab/2","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#content_type/2","title":"Xcribe.Helpers.Formatter.content_type/2","type":"function","doc":"return the content type by a list of header params Options: default: a value to be returned when not found content-type header."},{"ref":"Xcribe.Helpers.Formatter.html#fetch_key/3","title":"Xcribe.Helpers.Formatter.fetch_key/3","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#format_body/2","title":"Xcribe.Helpers.Formatter.format_body/2","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#format_path_parameter/1","title":"Xcribe.Helpers.Formatter.format_path_parameter/1","type":"function","doc":"Format the path params. format_path_parameter(&quot;user_id&quot;) iex&gt; &quot;userId&quot;"},{"ref":"Xcribe.Helpers.Formatter.html#ident_lines/2","title":"Xcribe.Helpers.Formatter.ident_lines/2","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#path_ending_arg/1","title":"Xcribe.Helpers.Formatter.path_ending_arg/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#prepare_and_captalize/1","title":"Xcribe.Helpers.Formatter.prepare_and_captalize/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#prepare_and_upcase/1","title":"Xcribe.Helpers.Formatter.prepare_and_upcase/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#purge_string/1","title":"Xcribe.Helpers.Formatter.purge_string/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#remove_ending_argument/1","title":"Xcribe.Helpers.Formatter.remove_ending_argument/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#remove_underline/1","title":"Xcribe.Helpers.Formatter.remove_underline/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#replace_template/2","title":"Xcribe.Helpers.Formatter.replace_template/2","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#tab/1","title":"Xcribe.Helpers.Formatter.tab/1","type":"function","doc":""},{"ref":"Xcribe.Helpers.Formatter.html#type_of/1","title":"Xcribe.Helpers.Formatter.type_of/1","type":"function","doc":""},{"ref":"readme.html","title":"README","type":"extras","doc":"XCribe XCribe is a doc generator for Rest APIs built with Phoenix. The documentation is generated by the test specs. Currently both Blueprint and Swagger (OpenAPI Spec 3.0) syntax is supported. In the future other formats will be added."},{"ref":"readme.html#installation","title":"README - Installation","type":"extras","doc":"Add XCribe to your application mix.exs def deps do [ {:xcribe, &quot;~&gt; 0.3&quot;} ] end Update deps mix deps.get XCribe requires that you create an &quot;Information Module&quot;. This module define the custom information about your API documentation. Create a module that uses Xcribe.Information defmodule YourAppWeb.Support.DocInformation do use Xcribe.Information xcribe_info do name &quot;Your awesome API&quot; description &quot;The best API on the world&quot; host(&quot;http://your-api.us&quot;) end end Add a new configuration with the created module config/test.exs config :xcribe, :information_source, YourAppWeb.Support.DocInformation config :xcribe, :doc_format, :api_blueprint # or :swagger Next, in your test/test_helper.exs you should configure ExUnit to use XCribe formatter. You would probably like to keep the default ExUnit.CLIFormatter as well. test/test_helper.exs ExUnit.start(formatters: [ExUnit.CLIFormatter, Xcribe.Formatter])"},{"ref":"readme.html#usage","title":"README - Usage","type":"extras","doc":"XCribe generates documentation from Plug.Conn struct used on your tests. To document a route you need pass the conn struct to macro document. First import the module Xcribe.Helpers.Document on your /test/support/conn_case.ex, that way you will have the document macro available on your test specs. /test/support/conn_case.ex defmodule YourAppWeb.ConnCase do use ExUnit.CaseTemplate using do quote do ... # import Xcribe macro import Xcribe.Helpers.Document ... end end end Now in your tests you should call the macro document with the conn struct test &quot;get posts&quot;, %{conn: conn} do response = conn |&gt; get(&quot;/posts&quot;) |&gt; document() |&gt; json_response(200) assert response == [] end you can specify a custom request name by passing an argument as: &quot;description&quot; to the macro test &quot;get posts&quot;, %{conn: conn} do response = conn |&gt; get(&quot;/posts&quot;) |&gt; document(as: &quot;index request&quot;) |&gt; json_response(200) assert response == [] end To generate the doc file run mix test with an env var XCRIBE_ENV=true XCRIBE_ENV=true mix test A file api_doc.apib will be created with the documentation if ApiBlueprint is configured. If Swagger format is chosen, then openapi.json file will be created. Rendering HTML The output file is write in Blueprint sintax. To render to HTML you can use the tools listed at APIBLUEPRINT.ORG If Swagger format is configured, Swagger UI can be used to display Swagger documentation."},{"ref":"readme.html#configure","title":"README - Configure","type":"extras","doc":"You can add this configurations to your config/test.ex information_source: the module with doc information output: a custom name to the output file format: ApiBlueprint or Swagger formats env_var: a custom name to the env to active XCribe.Formatter json_library: The library to be used for json decode/encode. See Xcribe.JSON Example config :xcribe, [ information_source: YourAppWeb.Information, output: &quot;API-DOCUMENTATION.apib&quot;, format: :swagger # or :api_blueprint, env_var: &quot;DOC_API&quot;, json_library: Jason ]"}]